<?php
/**
 * Catch Box Custom Social Icons
 *
 * @package Catch Themes
 * @subpackage Catch Box
 * @since Catch Box 3.6.7
 */

$wp_customize->add_setting( 'catchbox_theme_options[custom_social_icons]', array(
		'default'           => $defaults['custom_social_icons'],
		'sanitize_callback' => 'catchbox_sanitize_number_range',
	)
);

$wp_customize->add_control( 'catchbox_theme_options[custom_social_icons]', array(
	'input_attrs' => array(
		'min'   => 0,
		'max'   => 10,
		'step'  => 1,
		'style' => 'width: 45px;'
		),
	'label'    	=> esc_html__( 'Number of Custom Social Icons', 'catch-box-pro' ),
	'section' 	=> 'catchbox_theme_custom_social_links',
	'settings'	=> 'catchbox_theme_options[custom_social_icons]',
	'type'		=> 'number'
	)
);

//loop for custom social icons
for( $i = 1; $i <= $options['custom_social_icons'] ; $i++ ){
	$wp_customize->add_setting( 'catchbox_theme_options[custom_social_icon_note_'. $i .']', array(
		'sanitize_callback'	=> 'sanitize_text_field',
	) );

	$wp_customize->add_control( new Catchbox_Note_Control( $wp_customize, 'custom_social_icon_note_'. $i, array(
		'label'		=> esc_html__( 'Custom Social Icon #', 'catch-box-pro' ) . $i,
		'section'  	=> 'catchbox_theme_custom_social_links',
		'settings'	=> 'catchbox_theme_options[custom_social_icon_note_'. $i .']',
		'type'     	=> 'description',
		) ) );

		$wp_customize->add_setting( 'catchbox_theme_options[custom_social_icon_title_'. $i .']', array(
		'sanitize_callback'	=> 'sanitize_text_field',
	) );

	$wp_customize->add_control(  'catchbox_theme_options[custom_social_icon_title_'. $i .']', array(
		'label'		=> esc_html__( 'Title', 'catch-box-pro' ),
		'section'   => 'catchbox_theme_custom_social_links',
		'settings'  => 'catchbox_theme_options[custom_social_icon_title_'. $i .']',
	) );

	$wp_customize->add_setting( 'catchbox_theme_options[custom_social_icon_image_'. $i .']', array(
		'sanitize_callback'	=> 'catchbox_sanitize_image',
	) );

	$wp_customize->add_control( new WP_Customize_Image_Control( $wp_customize, 'custom_social_icon_image_'. $i , array(
		'label'		=> esc_html__( 'Image', 'catch-box-pro' ),
		'section'   => 'catchbox_theme_custom_social_links',
		'settings'  => 'catchbox_theme_options[custom_social_icon_image_'. $i .']',
	) ) );

		$wp_customize->add_setting( 'catchbox_theme_options[custom_social_icon_image_hover_'. $i .']', array(
		'sanitize_callback'	=> 'catchbox_sanitize_image',
	) );

	$wp_customize->add_control( new WP_Customize_Image_Control( $wp_customize, 'custom_social_icon_image_hover_'. $i , array(
		'label'		=> esc_html__( 'Hover Image(Optional)', 'catch-box-pro' ),
		'section'   => 'catchbox_theme_custom_social_links',
		'settings'  => 'catchbox_theme_options[custom_social_icon_image_hover_'. $i .']',
	) ) );

	$wp_customize->add_setting( 'catchbox_theme_options[custom_social_icon_link_'. $i .']', array(
		'sanitize_callback'	=> 'esc_url_raw',
	) );

	$wp_customize->add_control(  'catchbox_theme_options[custom_social_icon_link_'. $i .']', array(
		'label'		=> esc_html__( 'Link', 'catch-box-pro' ),
		'section'   => 'catchbox_theme_custom_social_links',
		'settings'  => 'catchbox_theme_options[custom_social_icon_link_'. $i .']',
	) );
}
