<?php
/**
 * The Template for displaying all single posts.
 *
 * @package Catch_Box
 */

get_header(); ?>

<?php 
//Getting data from Theme Options Panel
$options  = catchbox_get_options();

			// Start the loop.
			while ( have_posts() ) : the_post();

				// Include the single post content template.
				get_template_part( 'content', 'single' );

	            // If comments are open or we have at least one comment, load up the comment template
				if ( ( comments_open() || '0' != get_comments_number() ) && ( $options['commenting_setting'] != 'disable' ) ) {
					comments_template( '', true );
				}

				// Previous/next post navigation.
				the_post_navigation( array(
					'next_text' => '<span class="meta-nav" aria-hidden="true">' . __( 'Next <span class="nav-icon">&rarr;</span>', 'catch-box-pro' ) . '</span> ' .
						'<span class="screen-reader-text">' . __( 'Next post:', 'catch-box-pro' ) . '</span> ' .
						'<span class="post-title">%title</span>',
					'prev_text' => '<span class="meta-nav" aria-hidden="true">' . __( '<span class="nav-icon">&larr;</span> Previous', 'catch-box-pro' ) . '</span> ' .
						'<span class="screen-reader-text">' . __( 'Previous post:', 'catch-box-pro' ) . '</span> ' .
						'<span class="post-title">%title</span>',
				) );

			// End of the loop.
			endwhile;
			?>

		</div><!-- #content -->

		<?php
        /**
         * catchbox_after_content hook
         *
         */
        do_action( 'catchbox_after_content' ); ?>

	</div><!-- #primary -->

	<?php
    /**
     * catchbox_after_primary hook
     *
     */
    do_action( 'catchbox_after_primary' ); ?>

<?php get_sidebar(); ?>

<?php get_footer(); ?>